#!/usr/bin/perl -w
# $Id: compute_composite_score.pl,v 1.5 2010/07/07 13:18:00 rnl14480 Exp $

# This script loads the calculated score onto the database

use strict;
use lib qw(../lib/);

use BAOBAB::PrecursorWrapper;
use BAOBAB::Precursor;
use BAOBAB::Wrapper;
use DBI;

my $dbh = DBI->connect(
	$BAOBAB::Wrapper::dsn, $BAOBAB::Wrapper::user,
	$BAOBAB::Wrapper::password, { RaiseError => 1, AutoCommit => 0 }
) || die "Could not connect to the database : $DBI::errstr\n";
$dbh->{mysql_auto_reconnect} = 1;

die "Usage: $0 data-dir\n" unless scalar(@ARGV) >= 1;
my $data = shift;

my @organisms = qw(ada aga dmel);
my $pw = BAOBAB::PrecursorWrapper->new( dbh => $dbh );

foreach my $org (@organisms) {

	print "\nProcessing organism $org...\n";
	my $rfile;
	open( $rfile, $data . "cscore_" . $org . ".out" )
	  or die "Cannot open score file for $org : $!\n";

	my $count = 0;
	while (<$rfile>) {
		chomp;
		my @fields = split /:/;
		my ( $id, $score ) = @fields;

		$count++;
		print "\r$count";

		my $p = $pw->read( id => $id, no_cache => 1 );
		$p->score($score);
		$pw->write;
	}
}

$dbh->disconnect;
